# remirepo/fedora spec file for php-keradus-cli-executor
#
# Copyright (c) 2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    36a59199b9f8a8d5d65051ab4fa932b8d65fe8fd
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     keradus
%global gh_project   cli-executor
%global ns_vendor    Keradus
%global ns_project   CliExecutor
%global php_home     %{_datadir}/php
%global with_tests   0%{!?_without_tests:1}

Name:           php-%{gh_owner}-%{gh_project}
Version:        1.0.0
Release:        1%{?dist}
Summary:        CLI execution wrapper

Group:          Development/Libraries
License:        MIT
URL:            https://github.com/%{gh_owner}/%{gh_project}
# git snapshot to get upstream test suite
Source0:        %{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
%if %{with_tests}
# For tests
BuildRequires:  php-cli
BuildRequires:  php(language) >= 5.3.6
BuildRequires:  php-spl
%if 0%{?fedora} >= 26
BuildRequires:  php-composer(symfony/process) < 5
%else
BuildRequires:  php-composer(symfony/process) < 4
%endif
# From composer.json, "require-dev": {
#        "maglnet/composer-require-checker": "^0.1.6",
#        "friendsofphp/php-cs-fixer": "^2.9"
# Autoloader
BuildRequires:  php-composer(fedora/autoloader)
%endif

# From composer.json, "require": {
#        "php": "^5.3.6 || ^7.0",
#        "symfony/process": "^2.3 | ^3 | ^4"
Requires:       php(language) >= 5.3.6
%if 0%{?fedora} >= 26
Requires:       php-composer(symfony/process) < 5
%else
Requires:       php-composer(symfony/process) < 4
%endif
# From phpcompatinfo report for version 1.0.0
Requires:       php-spl
# Autoloader
Requires:       php-composer(fedora/autoloader)

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}


%description
CLI execution wrapper.

Autoloader: %{php_home}/%{ns_vendor}/%{ns_project}/autoload.php


%prep
%setup -q -n %{gh_project}-%{gh_commit}


%build
: Create autoloader
cat <<'AUTOLOAD' | tee src/autoload.php
<?php
/* Autoloader for %{name} and its dependencies */
require_once '%{php_home}/Fedora/Autoloader/autoload.php';

\Fedora\Autoloader\Autoload::addPsr4('%{ns_vendor}\\%{ns_project}\\', __DIR__);
\Fedora\Autoloader\Dependencies::required([
    [
        '%{php_home}/Symfony4/Component/Process/autoload.php',
        '%{php_home}/Symfony3/Component/Process/autoload.php',
        '%{php_home}/Symfony/Component/Process/autoload.php',
    ],
]);
AUTOLOAD


%install
: Library
mkdir -p %{buildroot}%{php_home}/%{ns_vendor}
cp -pr src %{buildroot}%{php_home}/%{ns_vendor}/%{ns_project}


%check
%if %{with_tests}
: No test suite, minimal check for autoloader
php -r '
require "%{buildroot}%{php_home}/%{ns_vendor}/%{ns_project}/autoload.php";
$cmd = new %{ns_vendor}\%{ns_project}\CommandExecutor("php -v", ".");
exit($cmd->getResult()->getCode());
'
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc composer.json
%doc *.md
%dir %{php_home}/%{ns_vendor}
     %{php_home}/%{ns_vendor}/%{ns_project}


%changelog
* Thu Jan 11 2018 Remi Collet <remi@remirepo.net> - 1.0.0-1
- initial package, version 1.0.0
